#import "TitanPlugin.h"
#import "TitanSDK.h"

@implementation TitanPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"titan_plugin"
            binaryMessenger:[registrar messenger]];
  TitanPlugin* instance = [[TitanPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  NSString* ret = @"OK";
  if ([@"start" isEqualToString:call.method]) {
    NSLog(@"Titan Plugin Start");
    [TitanSDK start];
  }else if ([@"stop" isEqualToString:call.method]) {
    [TitanSDK stop];
  }else if ([@"setListenPort" isEqualToString:call.method]) {
    NSNumber* port = call.arguments[0];
    if(port != nil) {
        [TitanSDK setListenPort:[port integerValue]];
    }
  }else if ([@"setToken" isEqualToString:call.method]) {
    NSNumber* token = call.arguments[0];
    if(token != nil) {
        [TitanSDK setToken:[token integerValue]];
    }
  }else if ([@"setPauseTimeout" isEqualToString:call.method]) {
    NSNumber* timeout = call.arguments[0];
    NSLog(@"setPauseTimeout log %@", timeout);
    if(timeout != nil) {
      [TitanSDK setPauseTimeout:[timeout integerValue]];
    }
  }else if ([@"setSleepTimeout" isEqualToString:call.method]) {
    NSNumber* timeout = call.arguments[0];
    NSLog(@"setSleepTimeout log %@", timeout);
    if(timeout != nil) {
      [TitanSDK setPauseTimeout:[timeout integerValue]];
    }
  }else if ([@"addHttpHeaderBypassKey" isEqualToString:call.method]) {
    NSString *key = call.arguments[0];
    NSLog(@"add header key log %@", key);
    if (key != nil) {
        [TitanSDK addHttpHeaderBypassKey:key];
    }
  }else if ([@"getVodUrl" isEqualToString:call.method]) {
    NSString *url = call.arguments[0];
    NSString *option = call.arguments[1];
    if (url != nil) {
       ret = [TitanSDK getVodUrl:url option:option];
       if (ret == nil) {
         ret = url;
       }
    }
    NSLog(@"getVodUrl ret %@", ret);
  }else if ([@"getDownloadUrl" isEqualToString:call.method]) {
    NSString *url = call.arguments[0];
    NSString *option = call.arguments[1];
    if (url != nil) {
      ret = [TitanSDK getDownloadUrl:url option:option];
      if (ret == nil) {
        ret = url;
      }
    }
    NSLog(@"getDownloadUrl ret %@", ret);
  }else {
    result(FlutterMethodNotImplemented);
    NSLog(@"FlutterMethodNotImplemented %@", call.method);
  }
  if (ret == nil) {
    result(FlutterMethodNotImplemented);
  } else {
    result(ret);
  }
}

@end
