//
//  TitanSDK.h

#import <Foundation/Foundation.h>

@interface TitanSDK : NSObject

/**
 * @param  token 客户标识，请务必保证此token和提供的一致。
 */
+(void)setToken:(NSInteger)token;

+(void)setListenPort:(NSInteger)port;
+(void)setPauseTimeout:(NSInteger)timeout;
+(void)setSleepTimeout:(NSInteger)timeout;
+(void)addHttpHeaderBypassKey:(NSString*)key;
+(void)start;
+(void)stop;

/**
 * 获取视频播放加速URL *
 * @param userName 用户名
 * @param fileUrl 文件源站url
 * @param protocol 文件协议类型
 * @return 视频加速url
 */
+ (NSString*)getP2PUrl:(NSString*)userName fileUrl:(NSString*)url protocol:(NSString *)protocol;

/**
 * 获取视频播放加速URL *
 * @param userName 用户名
 * @param fileUrl 文件源站url
 * @param protocol 文件协议类型
 * @param option 文件参数
 * @return 视频加速url
 */
+ (NSString*)getP2PUrl:(NSString*)userName fileUrl:(NSString*)url protocol:(NSString *)protocol option:(NSString *)option;

/**
 * 获取视频播放加速URL *
 * @param fileUrl 文件源站url
 * @param option 文件参数
 * @return 视频Vod加速url
 */
+ (NSString*)getVodUrl:(NSString*)fileUrl option:(NSString *)option;

/**
 * 获取文件下载加速URL *
 * @param fileUrl 文件源站url
 * @param option 文件参数
 * @return 文件下载加速url
 */
+ (NSString*)getDownloadUrl:(NSString*)fileUrl option:(NSString *)option;

@end
